<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/lib/include/SigGen.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_sig_gen_8h_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">SigGen.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;ThreadManagerBase.h&quot;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &quot;File.h&quot;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">namespace </span>siggen</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;{</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;    <span class="keyword">class </span>Options;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno"><a class="line" href="classsiggen_1_1_sig_gen.html">   14</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classsiggen_1_1_sig_gen.html">SigGen</a></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    {</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        std::unique_ptr&lt;File&gt; m_OutputFile;                 </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        std::unique_ptr&lt;ThreadManagerBase&gt; m_ThreadManager; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <a class="code" href="classsiggen_1_1_sig_gen.html#a80d1e476682130f9dcba8d331f9b27be">SigGen</a> (<a class="code" href="classsiggen_1_1_options.html">Options</a> <span class="keyword">const</span> &amp; options);</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_sig_gen.html#a52cb2cae015089c5a352ff33e0f72419">ProcessToFile</a> ();</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_sig_gen.html#a6683e988d1a523acda77c5fb7c5edfbf">ProcessToBuffer</a> (std::vector&lt;char&gt; &amp; result);</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keyword">protected</span>:</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160; </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_sig_gen.html#a5d1a3b3fb8500415bc93a8ce9e62ef5c">WriteOutputFile</a> (std::vector&lt;char&gt; <span class="keyword">const</span> &amp; signatures);</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    };</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;} <span class="comment">// namespace siggen</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclasssiggen_1_1_options_html"><div class="ttname"><a href="classsiggen_1_1_options.html">siggen::Options</a></div><div class="ttdoc">configuration for generation of signatures file</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00020">Options.h:20</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_sig_gen_html_a52cb2cae015089c5a352ff33e0f72419"><div class="ttname"><a href="classsiggen_1_1_sig_gen.html#a52cb2cae015089c5a352ff33e0f72419">siggen::SigGen::ProcessToFile</a></div><div class="ttdeci">void ProcessToFile()</div><div class="ttdoc">reads input file block after block and generate signature for each one</div><div class="ttdef"><b>Definition:</b> <a href="_sig_gen_8cpp_source.html#l00068">SigGen.cpp:68</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_sig_gen_html"><div class="ttname"><a href="classsiggen_1_1_sig_gen.html">siggen::SigGen</a></div><div class="ttdoc">generates signature from input file and writes result to output file</div><div class="ttdef"><b>Definition:</b> <a href="_sig_gen_8h_source.html#l00014">SigGen.h:14</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_sig_gen_html_a80d1e476682130f9dcba8d331f9b27be"><div class="ttname"><a href="classsiggen_1_1_sig_gen.html#a80d1e476682130f9dcba8d331f9b27be">siggen::SigGen::SigGen</a></div><div class="ttdeci">SigGen(Options const &amp;options)</div><div class="ttdoc">generates signature from input file and writes result to output file</div><div class="ttdef"><b>Definition:</b> <a href="_sig_gen_8cpp_source.html#l00012">SigGen.cpp:12</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_sig_gen_html_a6683e988d1a523acda77c5fb7c5edfbf"><div class="ttname"><a href="classsiggen_1_1_sig_gen.html#a6683e988d1a523acda77c5fb7c5edfbf">siggen::SigGen::ProcessToBuffer</a></div><div class="ttdeci">void ProcessToBuffer(std::vector&lt; char &gt; &amp;result)</div><div class="ttdoc">reads input file block after block and generate signature for each one</div><div class="ttdef"><b>Definition:</b> <a href="_sig_gen_8cpp_source.html#l00076">SigGen.cpp:76</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_sig_gen_html_a5d1a3b3fb8500415bc93a8ce9e62ef5c"><div class="ttname"><a href="classsiggen_1_1_sig_gen.html#a5d1a3b3fb8500415bc93a8ce9e62ef5c">siggen::SigGen::WriteOutputFile</a></div><div class="ttdeci">void WriteOutputFile(std::vector&lt; char &gt; const &amp;signatures)</div><div class="ttdoc">writes signature from memory to file</div><div class="ttdef"><b>Definition:</b> <a href="_sig_gen_8cpp_source.html#l00082">SigGen.cpp:82</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_97aefd0d527b934f1d99a682da8fe6a9.html">lib</a></li><li class="navelem"><a class="el" href="dir_5a30104352ef4255dc24354b02eb2d20.html">include</a></li><li class="navelem"><b>SigGen.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
